(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('rxjs'), require('rxjs/operators')) :
    typeof define === 'function' && define.amd ? define('@k-adam/ngx-loading-spinner', ['exports', '@angular/core', 'rxjs', 'rxjs/operators'], factory) :
    (global = global || self, factory((global['k-adam'] = global['k-adam'] || {}, global['k-adam']['ngx-loading-spinner'] = {}), global.ng.core, global.rxjs, global.rxjs.operators));
}(this, (function (exports, core, rxjs, operators) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/ngx-loading-spinner.service.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NgxLoadingSpinnerService = /** @class */ (function () {
        function NgxLoadingSpinnerService() {
            this.visibleSubject = new rxjs.BehaviorSubject(false);
            this.showSubject = new rxjs.Subject();
            this.hideSubject = new rxjs.Subject();
            this._timeout = 10000;
            this.raceSubject();
        }
        Object.defineProperty(NgxLoadingSpinnerService.prototype, "timeout", {
            set: /**
             * @param {?} timeout
             * @return {?}
             */
            function (timeout) {
                this._timeout = timeout;
                this.showSubject.next();
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @private
         * @return {?}
         */
        NgxLoadingSpinnerService.prototype.raceSubject = /**
         * @private
         * @return {?}
         */
        function () {
            var _this = this;
            rxjs.race(this.showSubject.pipe(operators.debounce((/**
             * @return {?}
             */
            function () { return rxjs.timer(_this._timeout); }))), this.hideSubject)
                .pipe(operators.take(1))
                .subscribe((/**
             * @return {?}
             */
            function () {
                _this.updateState(false);
            }), (/**
             * @param {?} error
             * @return {?}
             */
            function (error) { return console.error(error); }), (/**
             * @return {?}
             */
            function () { return _this.raceSubject(); }));
        };
        /**
         * @return {?}
         */
        NgxLoadingSpinnerService.prototype.show = /**
         * @return {?}
         */
        function () {
            this.updateState(true);
            this.showSubject.next();
        };
        /**
         * @return {?}
         */
        NgxLoadingSpinnerService.prototype.hide = /**
         * @return {?}
         */
        function () {
            this.hideSubject.next();
        };
        /**
         * @private
         * @param {?} spinnerVisible
         * @return {?}
         */
        NgxLoadingSpinnerService.prototype.updateState = /**
         * @private
         * @param {?} spinnerVisible
         * @return {?}
         */
        function (spinnerVisible) {
            this.visibleSubject.next(spinnerVisible);
        };
        NgxLoadingSpinnerService.decorators = [
            { type: core.Injectable, args: [{
                        providedIn: 'root'
                    },] }
        ];
        /** @nocollapse */
        NgxLoadingSpinnerService.ctorParameters = function () { return []; };
        /** @nocollapse */ NgxLoadingSpinnerService.ngInjectableDef = core.ɵɵdefineInjectable({ factory: function NgxLoadingSpinnerService_Factory() { return new NgxLoadingSpinnerService(); }, token: NgxLoadingSpinnerService, providedIn: "root" });
        return NgxLoadingSpinnerService;
    }());
    if (false) {
        /** @type {?} */
        NgxLoadingSpinnerService.prototype.visibleSubject;
        /**
         * @type {?}
         * @private
         */
        NgxLoadingSpinnerService.prototype.showSubject;
        /**
         * @type {?}
         * @private
         */
        NgxLoadingSpinnerService.prototype.hideSubject;
        /**
         * @type {?}
         * @private
         */
        NgxLoadingSpinnerService.prototype._timeout;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/ngx-loading-spinner.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NgxLoadingSpinnerComponent = /** @class */ (function () {
        function NgxLoadingSpinnerComponent(service) {
            this.service = service;
            this.zIndex = 100;
            this.visible = false;
        }
        Object.defineProperty(NgxLoadingSpinnerComponent.prototype, "timeout", {
            set: /**
             * @param {?} v
             * @return {?}
             */
            function (v) {
                this.service.timeout = v;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        NgxLoadingSpinnerComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
            this.subscribeToService();
        };
        /**
         * @private
         * @return {?}
         */
        NgxLoadingSpinnerComponent.prototype.subscribeToService = /**
         * @private
         * @return {?}
         */
        function () {
            var _this = this;
            this.service.visibleSubject.subscribe((/**
             * @param {?} spinnerVisible
             * @return {?}
             */
            function (spinnerVisible) {
                _this.visible = spinnerVisible;
            }));
        };
        NgxLoadingSpinnerComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'ngx-loading-spinner',
                        template: "<div class=\"overlay noselect\" [class.on]=\"visible\" [class.off]=\"!visible\" [style.zIndex]=\"zIndex\">\r\n    <div class=\"spinner-container\">\r\n        <div class=\"lds-default\"><div></div><div></div><div></div><div></div><div></div><div></div><div></div><div></div><div></div><div></div><div></div><div></div></div>\r\n    </div>\r\n</div>\r\n",
                        styles: [".noselect{-webkit-touch-callout:none;-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none}.overlay{background-color:rgba(24,24,24,.5);position:fixed;top:0;left:0;width:100%;height:100%;-webkit-transition:opacity .5s;transition:opacity .5s;opacity:0;pointer-events:none}.overlay.on{opacity:1;pointer-events:auto}.spinner-container{height:100%;display:-webkit-box;display:flex;-webkit-box-pack:center;justify-content:center;-webkit-box-align:center;align-items:center}.lds-default{display:inline-block;position:relative;width:80px;height:80px}.lds-default div{position:absolute;width:6px;height:6px;background:#fff;border-radius:50%;-webkit-animation:1.2s linear infinite lds-default;animation:1.2s linear infinite lds-default}.lds-default div:nth-child(1){-webkit-animation-delay:0s;animation-delay:0s;top:37px;left:66px}.lds-default div:nth-child(2){-webkit-animation-delay:-.1s;animation-delay:-.1s;top:22px;left:62px}.lds-default div:nth-child(3){-webkit-animation-delay:-.2s;animation-delay:-.2s;top:11px;left:52px}.lds-default div:nth-child(4){-webkit-animation-delay:-.3s;animation-delay:-.3s;top:7px;left:37px}.lds-default div:nth-child(5){-webkit-animation-delay:-.4s;animation-delay:-.4s;top:11px;left:22px}.lds-default div:nth-child(6){-webkit-animation-delay:-.5s;animation-delay:-.5s;top:22px;left:11px}.lds-default div:nth-child(7){-webkit-animation-delay:-.6s;animation-delay:-.6s;top:37px;left:7px}.lds-default div:nth-child(8){-webkit-animation-delay:-.7s;animation-delay:-.7s;top:52px;left:11px}.lds-default div:nth-child(9){-webkit-animation-delay:-.8s;animation-delay:-.8s;top:62px;left:22px}.lds-default div:nth-child(10){-webkit-animation-delay:-.9s;animation-delay:-.9s;top:66px;left:37px}.lds-default div:nth-child(11){-webkit-animation-delay:-1s;animation-delay:-1s;top:62px;left:52px}.lds-default div:nth-child(12){-webkit-animation-delay:-1.1s;animation-delay:-1.1s;top:52px;left:62px}@-webkit-keyframes lds-default{0%,100%,20%,80%{-webkit-transform:scale(1);transform:scale(1)}50%{-webkit-transform:scale(1.5);transform:scale(1.5)}}@keyframes lds-default{0%,100%,20%,80%{-webkit-transform:scale(1);transform:scale(1)}50%{-webkit-transform:scale(1.5);transform:scale(1.5)}}"]
                    }] }
        ];
        /** @nocollapse */
        NgxLoadingSpinnerComponent.ctorParameters = function () { return [
            { type: NgxLoadingSpinnerService }
        ]; };
        NgxLoadingSpinnerComponent.propDecorators = {
            timeout: [{ type: core.Input }],
            zIndex: [{ type: core.Input }]
        };
        return NgxLoadingSpinnerComponent;
    }());
    if (false) {
        /** @type {?} */
        NgxLoadingSpinnerComponent.prototype.zIndex;
        /** @type {?} */
        NgxLoadingSpinnerComponent.prototype.visible;
        /**
         * @type {?}
         * @private
         */
        NgxLoadingSpinnerComponent.prototype.service;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/ngx-loading-spinner.module.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NgxLoadingSpinnerModule = /** @class */ (function () {
        function NgxLoadingSpinnerModule() {
        }
        /**
         * @return {?}
         */
        NgxLoadingSpinnerModule.forRoot = /**
         * @return {?}
         */
        function () {
            return {
                ngModule: NgxLoadingSpinnerModule,
                providers: [NgxLoadingSpinnerService]
            };
        };
        NgxLoadingSpinnerModule.decorators = [
            { type: core.NgModule, args: [{
                        declarations: [NgxLoadingSpinnerComponent],
                        imports: [],
                        exports: [NgxLoadingSpinnerComponent]
                    },] }
        ];
        return NgxLoadingSpinnerModule;
    }());

    exports.NgxLoadingSpinnerComponent = NgxLoadingSpinnerComponent;
    exports.NgxLoadingSpinnerModule = NgxLoadingSpinnerModule;
    exports.NgxLoadingSpinnerService = NgxLoadingSpinnerService;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=k-adam-ngx-loading-spinner.umd.js.map
